using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.IO;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Data.SqlClient;

public partial class _Default : System.Web.UI.Page
{
    protected void Upload(object sender, EventArgs e)
    {
        //Upload and save the File.
        string excelPath = Server.MapPath("~/Files/") + Path.GetFileName(fuUpload.PostedFile.FileName);
        fuUpload.SaveAs(excelPath);

        string conString = string.Empty;
        string storedProc = string.Empty;
        string sheet1 = string.Empty;
        string extension = Path.GetExtension(fuUpload.PostedFile.FileName);
        switch (extension)
        {
            case ".xls": //Excel 97-03.
                storedProc = "spx_ImportFromExcel03";
                conString = ConfigurationManager.ConnectionStrings["Excel03ConString"].ConnectionString;
                break;
            case ".xlsx": //Excel 07 or higher.
                storedProc = "spx_ImportFromExcel07";
                conString = ConfigurationManager.ConnectionStrings["Excel07+ConString"].ConnectionString;
                break;

        }

        //Read the Sheet Name.
        conString = string.Format(conString, excelPath);
        using (OleDbConnection excel_con = new OleDbConnection(conString))
        {
            excel_con.Open();
            sheet1 = excel_con.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null).Rows[0]["TABLE_NAME"].ToString();
            excel_con.Close();
        }

        //Call the Stored Procedure to import Excel data in Table.
        string constr = ConfigurationManager.ConnectionStrings["conString"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand(storedProc, con))
            {
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@SheetName", sheet1);
                cmd.Parameters.AddWithValue("@FilePath", excelPath);
                cmd.Parameters.AddWithValue("@HDR", "YES");
                cmd.Parameters.AddWithValue("@TableName", "tblPersons");
                cmd.Connection = con;
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
            }
        }
    }
}
